﻿using Syncfusion.Data;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.SfDataGrid.XForms;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace DataGridDemo
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();

            viewModel.CollectionChanged += ViewModelOnCollectionChanged;
            ViewModelOnCollectionChanged(this, null);
        }

        private void ViewModelOnCollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            if(viewModel.CustomInfoCollection.Count == 0)
                return;

            var keys = viewModel.CustomInfoCollection.First().GetKeys();
            var orderIdCol = myGrid.Columns[0];
            var employeeCol = myGrid.Columns[1];

            myGrid.Columns.Clear();
            myGrid.Columns.Add(orderIdCol);
            myGrid.Columns.Add(employeeCol);

            foreach (var key in keys)
            {
                GridTemplateColumn column = new GridTemplateColumn();
                column.MappingName = key;
                column.HeaderText = key;

                var dataTemplate = new DataTemplate(() =>
                {
                    var grid = new Grid();
                    grid.SetBinding(BindingContextProperty, key);
                    grid.SetBinding(BackgroundColorProperty, "CellColor");
                    grid.VerticalOptions = LayoutOptions.Center;
                    grid.HorizontalOptions = LayoutOptions.Center;


                    var label = new Label();
                    label.Margin = new Thickness(5, 3, 5, 3);
                    label.VerticalOptions = LayoutOptions.Center;
                    label.HorizontalOptions = LayoutOptions.Center;
                    label.SetBinding(Label.TextProperty, "Value");


                    grid.Children.Add(label);

                    return grid;
                });


                column.CellTemplate = dataTemplate;
                column.Width = 100;

                myGrid.Columns.Add(column);
            }

            myGrid.ItemsSource = viewModel.CustomInfoCollection;
        }
    }


}
