﻿using System;
using System.ComponentModel;

namespace DataGridDemo
{
    public class DynamicPropertyDescriptor : PropertyDescriptor
    {
        public DynamicPropertyDescriptor(string name) : base(name, null) { }
        public DynamicPropertyDescriptor(string name, Attribute[] attrs) : base(name, attrs) { }
        public override object GetValue(object component)
        {
            return ((CustomTypeDescriptorInfo)component).GetValue(Name);
        }
        public override void SetValue(object component, object value)
        {
            ((CustomTypeDescriptorInfo)component).SetData(Name, value as CellData);
        }
        public override void ResetValue(object component)
        {
            ((CustomTypeDescriptorInfo)component).SetData(Name, null);
        }
        public override bool CanResetValue(object component)
        {
            return true;
        }
        public override bool ShouldSerializeValue(object component)
        {
            return true;
        }
        public override Type PropertyType
        {
            get { return typeof(CellData); }
        }
        public override bool IsReadOnly
        {
            get { return true; }
        }
        public override Type ComponentType
        {
            get { return typeof(CustomTypeDescriptorInfo); }
        }
    }
}