﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections.Specialized;

namespace DataGridDemo
{
    public class ViewModel : INotifyPropertyChanged, INotifyCollectionChanged
    {
        ///------------------------------------------------
        private Repository orderRepository;
        private ObservableCollection<CustomTypeDescriptorInfo> _customInfoCollection;
        
        public ViewModel()
        {
            orderRepository = new Repository();
            GenerateRows();

        }

        public ObservableCollection<CustomTypeDescriptorInfo> CustomInfoCollection
        {
            get { return _customInfoCollection; }
            set
            {
                _customInfoCollection = value;
                RaisePropertyChanged("OrdersInfo");
            }
        }

        private void GenerateRows()
        {
            _customInfoCollection = orderRepository.GetOrderDetails(10);
          
        }

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;
        public event NotifyCollectionChangedEventHandler CollectionChanged;

        private void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        public  void OnCollectionChange(NotifyCollectionChangedEventArgs e)
        {
            if (CollectionChanged != null)
                CollectionChanged(this, e);
        }
        #endregion
    }
}
